Index: /branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/GAssist.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/GAssist.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/GAssist.cs	(revision 9392)
@@ -65,4 +65,7 @@
       get { return (ValueParameter<IntValue>)Parameters["PopulationSize"]; }
     }
+    public ValueParameter<MDLIterationOperator> MDLIterationOperatorParameter {
+      get { return (ValueParameter<MDLIterationOperator>)Parameters["MDLIterationOperator"]; }
+    }
     public IConstrainedValueParameter<IDefaultRuleOperator> DefaultRuleParameter {
       get { return (IConstrainedValueParameter<IDefaultRuleOperator>)Parameters["DefaultRule"]; }
@@ -121,4 +124,19 @@
     private ValueParameter<ItemCollection<IDiscretizer>> DiscretizersParameter {
       get { return (ValueParameter<ItemCollection<IDiscretizer>>)Parameters["Discretizers"]; }
+    }
+    public ValueParameter<IntValue> MDLActivationIterationParameter {
+      get { return (ValueParameter<IntValue>)Parameters["MDLActivationIteration"]; }
+    }
+    public ValueParameter<DoubleValue> InitialTheoryLengthRatioParameter {
+      get { return (ValueParameter<DoubleValue>)Parameters["InitialTheoryLengthRatio"]; }
+    }
+    public ValueParameter<DoubleValue> WeightRelaxFactorParameter {
+      get { return (ValueParameter<DoubleValue>)Parameters["WeightRelaxFactor"]; }
+    }
+    public ValueParameter<IntValue> WeightAdaptionIterationsParameter {
+      get { return (ValueParameter<IntValue>)Parameters["WeightAdaptionIterations"]; }
+    }
+    public ValueParameter<IntValue> NumberOfStrataParameter {
+      get { return (ValueParameter<IntValue>)Parameters["NumberOfStrata"]; }
     }
     #endregion
@@ -180,6 +198,18 @@
       get { return (RandomCreator)OperatorGraph.InitialOperator; }
     }
+    private VariableCreator VariableCreator {
+      get { return (VariableCreator)RandomCreator.Successor; }
+    }
+    private Placeholder MDLIterationPlaceholder {
+      get { return (Placeholder)VariableCreator.Successor; }
+    }
+    private ILASOperator ILASOperator {
+      get { return (ILASOperator)MDLIterationPlaceholder.Successor; }
+    }
+    private InitializeDiscretizersOperator InitializeDiscretizers {
+      get { return (InitializeDiscretizersOperator)ILASOperator.Successor; }
+    }
     private SolutionsCreator SolutionsCreator {
-      get { return (SolutionsCreator)RandomCreator.Successor; }
+      get { return (SolutionsCreator)InitializeDiscretizers.Successor; }
     }
     private GAssistMainLoop GeneticAlgorithmMainLoop {
@@ -204,16 +234,28 @@
       Parameters.Add(new ValueParameter<GAssistSpecialStageMultiOperator>("SpecialStages", "", new GAssistSpecialStageMultiOperator()));
       Parameters.Add(new ValueParameter<IntValue>("MaximumGenerations", "The maximum number of generations which should be processed.", new IntValue(1000)));
-      Parameters.Add(new FixedValueParameter<PercentValue>("SplitProbability", "", new PercentValue(0.05)));
-      Parameters.Add(new FixedValueParameter<PercentValue>("MergeProbability", "", new PercentValue(0.05)));
-      Parameters.Add(new FixedValueParameter<PercentValue>("StartReinitializeProbability", "", new PercentValue(0.05)));
-      Parameters.Add(new FixedValueParameter<PercentValue>("EndReinitializeProbability", "", new PercentValue(Double.Epsilon)));
-      Parameters.Add(new FixedValueParameter<PercentValue>("OneProbability", "", new PercentValue(0.75)));
-      Parameters.Add(new FixedValueParameter<IntValue>("MaximumNumberOfIntervals", "", new IntValue(5)));
-      Parameters.Add(new FixedValueParameter<IntValue>("InitialNumberOfRules", "", new IntValue(20)));
+      Parameters.Add(new ValueParameter<PercentValue>("SplitProbability", "", new PercentValue(0.05)));
+      Parameters.Add(new ValueParameter<PercentValue>("MergeProbability", "", new PercentValue(0.05)));
+      Parameters.Add(new ValueParameter<PercentValue>("StartReinitializeProbability", "", new PercentValue(0.05)));
+      Parameters.Add(new ValueParameter<PercentValue>("EndReinitializeProbability", "", new PercentValue(Double.Epsilon)));
+      Parameters.Add(new ValueParameter<PercentValue>("OneProbability", "", new PercentValue(0.75)));
+      Parameters.Add(new ValueParameter<IntValue>("MaximumNumberOfIntervals", "", new IntValue(5)));
+      Parameters.Add(new ValueParameter<IntValue>("InitialNumberOfRules", "", new IntValue(20)));
+      Parameters.Add(new ValueParameter<MDLIterationOperator>("MDLIterationOperator", "", new MDLIterationOperator()));
       Parameters.Add(new ConstrainedValueParameter<IDefaultRuleOperator>("DefaultRule", ""));
       Parameters.Add(new ConstrainedValueParameter<IDiscreteDoubleValueModifier>("ReinitializeCurveOperator", ""));
       Parameters.Add(new ValueParameter<ItemCollection<IDiscretizer>>("Discretizers", "", new ItemCollection<IDiscretizer>()));
 
+      Parameters.Add(new ValueParameter<IntValue>("MDLActivationIteration", "", new IntValue(25)));
+      Parameters.Add(new ValueParameter<DoubleValue>("InitialTheoryLengthRatio", "", new DoubleValue(0.075)));
+      Parameters.Add(new ValueParameter<DoubleValue>("WeightRelaxFactor", "", new DoubleValue(0.9)));
+      Parameters.Add(new ValueParameter<IntValue>("WeightAdaptionIterations", "", new IntValue(10)));
+
+      Parameters.Add(new ValueParameter<IntValue>("NumberOfStrata", "", new IntValue(2)));
+
       RandomCreator randomCreator = new RandomCreator();
+      VariableCreator variableCreator = new VariableCreator();
+      Placeholder mdlIterationPlaceholder = new Placeholder();
+      ILASOperator ilasOperator = new ILASOperator();
+      InitializeDiscretizersOperator initializeDiscretizers = new InitializeDiscretizersOperator();
       SolutionsCreator solutionsCreator = new SolutionsCreator();
       SubScopesCounter subScopesCounter = new SubScopesCounter();
@@ -227,5 +269,19 @@
       randomCreator.SetSeedRandomlyParameter.ActualName = SetSeedRandomlyParameter.Name;
       randomCreator.SetSeedRandomlyParameter.Value = null;
-      randomCreator.Successor = solutionsCreator;
+      randomCreator.Successor = variableCreator;
+
+      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Generations", new IntValue(0))); // Class GAssistMainLoop expects this to be called Generations
+      variableCreator.Successor = mdlIterationPlaceholder;
+
+      mdlIterationPlaceholder.Name = "MDL Iteration Operator";
+      mdlIterationPlaceholder.OperatorParameter.ActualName = MDLIterationOperatorParameter.Name;
+      mdlIterationPlaceholder.Successor = ilasOperator;
+
+      ilasOperator.RandomParameter.ActualName = randomCreator.RandomParameter.ActualName;
+      ilasOperator.NumberOfStrataParameter.ActualName = NumberOfStrataParameter.Name;
+      ilasOperator.Successor = initializeDiscretizers;
+
+      initializeDiscretizers.DiscretizersParameter.ActualName = DiscretizersParameter.Name;
+      initializeDiscretizers.Successor = solutionsCreator;
 
       solutionsCreator.NumberOfSolutionsParameter.ActualName = PopulationSizeParameter.Name;
@@ -240,4 +296,5 @@
       resultsCollector.Successor = mainLoop;
 
+      mainLoop.MDLIterationParameter.ActualName = MDLIterationOperatorParameter.Name;
       mainLoop.DefaultRuleParameter.ActualName = DefaultRuleParameter.Name;
       mainLoop.SelectorParameter.ActualName = SelectorParameter.Name;
@@ -348,7 +405,12 @@
       ParameterizeStochasticOperator(Problem.SolutionCreator);
       ParameterizeStochasticOperator(Problem.Evaluator);
-      foreach (IOperator op in Problem.Operators.OfType<IOperator>()) ParameterizeStochasticOperator(op);
+      ParameterizeMDLOperator(Problem.Evaluator);
+      ParameterizeIterationBasedOperators(Problem.Evaluator);
+      foreach (IOperator op in Problem.Operators.OfType<IOperator>()) {
+        ParameterizeStochasticOperator(op);
+      }
       ParameterizeSolutionsCreator();
       ParameterizeGeneticAlgorithmMainLoop();
+      ParameterizeMDL();
       ParameterizeSelectors();
       ParameterizeAnalyzers();
@@ -359,5 +421,21 @@
       UpdateAnalyzers();
       Problem.Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
+      ILASOperator.ProblemDataParameter.ActualName = Problem.ProblemDataParameter.Name;
+      InitializeDiscretizers.ProblemDataParameter.ActualName = Problem.ProblemDataParameter.Name;
       base.OnProblemChanged();
+    }
+
+    private void ParameterizeMDL() {
+      MDLIterationOperatorParameter.Value.QualityParameter.ActualName = Problem.Evaluator.QualityParameter.ActualName;
+      //change
+      MDLIterationOperatorParameter.Value.IndividualParameter.ActualName = "DecisionList";
+      MDLIterationOperatorParameter.Value.ProblemDataParameter.ActualName = Problem.ProblemDataParameter.Name;
+      MDLIterationOperatorParameter.Value.MaximizationParameter.ActualName = Problem.MaximizationParameter.Name;
+
+      MDLIterationOperatorParameter.Value.InitialTheoryLengthRatioParameter.ActualName = InitialTheoryLengthRatioParameter.Name;
+      MDLIterationOperatorParameter.Value.MDLActivationIterationParameter.ActualName = MDLActivationIterationParameter.Name;
+      MDLIterationOperatorParameter.Value.WeightAdaptionIterationsParameter.ActualName = WeightAdaptionIterationsParameter.Name;
+      MDLIterationOperatorParameter.Value.WeightRelaxFactorParameter.ActualName = WeightRelaxFactorParameter.Name;
+      MDLIterationOperatorParameter.Value.IterationsParameter.ActualName = "Generations";
     }
 
@@ -374,4 +452,5 @@
       ParameterizeAnalyzers();
       Problem.Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
+      Problem.Evaluator.StrataParameter.ActualName = ILASOperator.StrataParameter.ActualName;
       base.Problem_EvaluatorChanged(sender, e);
     }
@@ -433,4 +512,10 @@
         stochasticOp.RandomParameter.ActualName = RandomCreator.RandomParameter.ActualName;
         stochasticOp.RandomParameter.Hidden = true;
+      }
+    }
+    private void ParameterizeMDLOperator(IOperator op) {
+      IMDLCalculatorBasedOperator stochasticOp = op as IMDLCalculatorBasedOperator;
+      if (stochasticOp != null) {
+        stochasticOp.MDLCalculatorParameter.ActualName = MDLIterationOperatorParameter.Value.MDLCalculatorParameter.ActualName;
       }
     }
@@ -469,11 +554,20 @@
       }
     }
+    private void ParameterizeIterationBasedOperators(IOperator op) {
+      IIterationBasedOperator iterationOp = op as IIterationBasedOperator;
+      if (iterationOp != null) {
+        ParameterizeIterationBasedOperators(iterationOp);
+      }
+    }
+    private void ParameterizeIterationBasedOperators(IIterationBasedOperator op) {
+      op.IterationsParameter.ActualName = "Generations";
+      op.IterationsParameter.Hidden = true;
+      op.MaximumIterationsParameter.ActualName = "MaximumGenerations";
+      op.MaximumIterationsParameter.Hidden = true;
+    }
     private void ParameterizeIterationBasedOperators() {
       if (Problem != null) {
         foreach (IIterationBasedOperator op in Problem.Operators.OfType<IIterationBasedOperator>()) {
-          op.IterationsParameter.ActualName = "Generations";
-          op.IterationsParameter.Hidden = true;
-          op.MaximumIterationsParameter.ActualName = "MaximumGenerations";
-          op.MaximumIterationsParameter.Hidden = true;
+          ParameterizeIterationBasedOperators(op);
         }
       }
Index: /branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/GAssistMainLoop.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/GAssistMainLoop.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Algorithms.GAssist/3.3/GAssistMainLoop.cs	(revision 9392)
@@ -61,4 +61,7 @@
     public ValueLookupParameter<IOperator> MutatorParameter {
       get { return (ValueLookupParameter<IOperator>)Parameters["Mutator"]; }
+    }
+    public ValueLookupParameter<IOperator> MDLIterationParameter {
+      get { return (ValueLookupParameter<IOperator>)Parameters["MDLIteration"]; }
     }
     public ValueLookupParameter<IOperator> DefaultRuleParameter {
@@ -134,13 +137,14 @@
       Parameters.Add(new ValueLookupParameter<IOperator>("ReinitializationProbabilityOperator", ""));
       Parameters.Add(new ValueLookupParameter<IOperator>("DefaultRule", ""));
+      Parameters.Add(new ValueLookupParameter<IOperator>("MDLIteration", ""));
       Parameters.Add(new ScopeParameter("CurrentScope", "The current scope which represents a population of solutions on which the genetic algorithm should be applied."));
       #endregion
 
       #region Create operators
-      VariableCreator variableCreator = new VariableCreator();
       ResultsCollector resultsCollector1 = new ResultsCollector();
       Placeholder analyzer1 = new Placeholder();
+      Placeholder mdlIterationOperator = new Placeholder();
+      Placeholder defaultRuleOperator = new Placeholder();
       Placeholder reinitializationProbabilityOperator = new Placeholder();
-      Placeholder defaultRuleOperator = new Placeholder();
       Placeholder selector = new Placeholder();
       SubScopesProcessor subScopesProcessor1 = new SubScopesProcessor();
@@ -167,6 +171,4 @@
       ConditionalBranch conditionalBranch = new ConditionalBranch();
 
-      variableCreator.CollectedValues.Add(new ValueParameter<IntValue>("Generations", new IntValue(0))); // Class GeneticAlgorithm expects this to be called Generations
-
       resultsCollector1.CollectedValues.Add(new LookupParameter<IntValue>("Generations"));
       resultsCollector1.ResultsParameter.ActualName = "Results";
@@ -174,4 +176,7 @@
       analyzer1.Name = "Analyzer";
       analyzer1.OperatorParameter.ActualName = "Analyzer";
+
+      mdlIterationOperator.Name = "MDL Iteration Operator";
+      mdlIterationOperator.OperatorParameter.ActualName = MDLIterationParameter.Name;
 
       defaultRuleOperator.Name = "Default Rule Operator";
@@ -234,8 +239,8 @@
 
       #region Create operator graph
-      OperatorGraph.InitialOperator = variableCreator;
-      variableCreator.Successor = resultsCollector1;
+      OperatorGraph.InitialOperator = resultsCollector1;
       resultsCollector1.Successor = analyzer1;
-      analyzer1.Successor = defaultRuleOperator;
+      analyzer1.Successor = mdlIterationOperator;
+      mdlIterationOperator.Successor = defaultRuleOperator;
       defaultRuleOperator.Successor = reinitializationProbabilityOperator;
       reinitializationProbabilityOperator.Successor = selector;
@@ -272,5 +277,5 @@
       comparator.Successor = analyzer2;
       analyzer2.Successor = conditionalBranch;
-      conditionalBranch.FalseBranch = defaultRuleOperator;
+      conditionalBranch.FalseBranch = mdlIterationOperator;
       conditionalBranch.TrueBranch = null;
       conditionalBranch.Successor = null;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionList.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionList.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionList.cs	(revision 9392)
@@ -80,17 +80,19 @@
 
     // for convenience
-    public IEnumerable<IAction> Evaluate(IEnumerable<DecisionListInput> input) {
-      int numberOfAliveRules;
-      return Evaluate(input, out numberOfAliveRules);
+    public IEnumerable<IAction> Evaluate(IEnumerable<IGAssistInput> input) {
+      ItemSet<Rule> aliveRules;
+      return Evaluate(input, out aliveRules);
     }
     // for convenience
-    public IEnumerable<IAction> Evaluate(IEnumerable<DecisionListInput> input, out int numberOfAliveRules) {
+    public IEnumerable<IAction> Evaluate(IEnumerable<IGAssistInput> input, out ItemSet<Rule> aliveRules) {
       double theoryLengtgh;
-      return Evaluate(input, out numberOfAliveRules, out theoryLengtgh);
+      return Evaluate(input, out aliveRules, out theoryLengtgh);
     }
-    public IEnumerable<IAction> Evaluate(IEnumerable<DecisionListInput> input, out int numberOfAliveRules, out double theoryLengtgh) {
+    public IEnumerable<IAction> Evaluate(IEnumerable<IGAssistInput> input, out ItemSet<Rule> aliveRules, out double theoryLength) {
       var estimated = new List<IAction>();
-      var activatedRules = new HashSet<Rule>();
+      var activatedRules = new ItemSet<Rule>();
+      int count = 0;
       foreach (var dli in input) {
+        count++;
         foreach (var rule in rules) {
           if (rule.MatchInput(dli)) {
@@ -100,9 +102,18 @@
           }
         }
+        if (count > estimated.Count) {
+          estimated.Add(defaultAction);
+        }
       }
-      numberOfAliveRules = activatedRules.Count;
-      theoryLengtgh = activatedRules.Sum(x => x.ComputeTheoryLength());
+      aliveRules = activatedRules;
+      theoryLength = activatedRules.Sum(x => x.ComputeTheoryLength());
 
       return estimated;
+    }
+
+    public void RemoveRules(IEnumerable<Rule> deadRules) {
+      foreach (var deadRule in deadRules) {
+        Rules.Remove(deadRule);
+      }
     }
 
@@ -145,4 +156,8 @@
       }
     }
+
+    public IGAssistSolution CreateGAssistSolution(IGAssistNichesProblemData problemData) {
+      return new DecisionListSolution(this, problemData);
+    }
     #endregion
   }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionListInput.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionListInput.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionListInput.cs	(revision 9392)
@@ -26,4 +26,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Optimization.Operators.LCS;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -31,5 +32,5 @@
   [StorableClass]
   [Item("DecisionListInput", "")]
-  public class DecisionListInput : Item {
+  public class DecisionListInput : Item, IGAssistInput {
 
     [Storable]
@@ -81,4 +82,13 @@
       return sb.ToString();
     }
+
+    #region IGAssistInput Members
+    public IEnumerable<string> VariableNames {
+      get { return inputDictionary.Keys; }
+    }
+    public string GetVariableValue(string variableName) {
+      return inputDictionary[variableName];
+    }
+    #endregion
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionListSolution.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionListSolution.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/DecisionListSolution.cs	(revision 9392)
@@ -27,4 +27,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators.LCS;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -38,4 +39,5 @@
     private const string TestAccuracyResultName = "Accuracy (test)";
     private const string TrainingNumberOfAliveRulesName = "Number of alive rules (training)";
+    private const string TrainingAliveRulesName = "Alive Rules (training)";
     //private const string TestNumberOfAliveRules = "Number of alive rules (test)";
     private const string TrainingTheoryLengthName = "Theory Length (training)";
@@ -54,4 +56,8 @@
       private set { ((IntValue)this[TrainingNumberOfAliveRulesName].Value).Value = value; }
     }
+    public ItemSet<Rule> TrainingAliveRules {
+      get { return (ItemSet<Rule>)this[TrainingAliveRulesName].Value; }
+      private set { this[TrainingAliveRulesName].Value = value; }
+    }
     public double TrainingTheoryLength {
       get { return ((DoubleValue)this[TrainingTheoryLengthName].Value).Value; }
@@ -61,4 +67,8 @@
       get { return ((DoubleValue)this[TrainingExceptionsLengthName].Value).Value; }
       private set { ((DoubleValue)this[TrainingExceptionsLengthName].Value).Value = value; }
+    }
+
+    public int Classes {
+      get { return ProblemData.Classes; }
     }
 
@@ -79,6 +89,6 @@
     }
 
-    public IDecisionListClassificationProblemData ProblemData {
-      get { return (IDecisionListClassificationProblemData)this[ProblemDataResultName].Value; }
+    public IGAssistNichesProblemData ProblemData {
+      get { return (IGAssistNichesProblemData)this[ProblemDataResultName].Value; }
       set {
         if (this[ProblemDataResultName].Value != value) {
@@ -100,5 +110,5 @@
       description = original.Description;
     }
-    public DecisionListSolution(DecisionList model, IDecisionListClassificationProblemData problemData)
+    public DecisionListSolution(DecisionList model, IGAssistNichesProblemData problemData)
       : base() {
       name = ItemName;
@@ -109,4 +119,5 @@
       Add(new Result(TestAccuracyResultName, "Accuracy of the model on the test partition (percentage of correctly classified instances).", new PercentValue()));
       Add(new Result(TrainingNumberOfAliveRulesName, "", new IntValue()));
+      Add(new Result(TrainingAliveRulesName, "", new ItemSet<Rule>()));
       Add(new Result(TrainingTheoryLengthName, "", new DoubleValue()));
       Add(new Result(TrainingExceptionsLengthName, "", new DoubleValue()));
@@ -123,8 +134,9 @@
       var originalTrainingCondition = ProblemData.FetchInput(ProblemData.TrainingIndices);
       var originalTestCondition = ProblemData.FetchInput(ProblemData.TestIndices);
-      int numberOfAliveRules;
+      ItemSet<Rule> aliveRules;
       double theoryLength;
-      var estimatedTraining = Model.Evaluate(originalTrainingCondition, out numberOfAliveRules, out theoryLength);
-      TrainingNumberOfAliveRules = numberOfAliveRules;
+      var estimatedTraining = Model.Evaluate(originalTrainingCondition, out aliveRules, out theoryLength);
+      TrainingNumberOfAliveRules = aliveRules.Count;
+      TrainingAliveRules = aliveRules;
       TrainingTheoryLength = theoryLength;
       var estimatedTest = Model.Evaluate(originalTestCondition);
@@ -139,5 +151,5 @@
     }
 
-    private double CalculateAccuracy(IEnumerable<IAction> original, IEnumerable<IAction> estimated) {
+    public static double CalculateAccuracy(IEnumerable<IGAssistNiche> original, IEnumerable<IGAssistNiche> estimated) {
       double correctClassified = 0;
 
@@ -147,5 +159,6 @@
 
       while (originalEnumerator.MoveNext() && estimatedActionEnumerator.MoveNext()) {
-        if (originalEnumerator.Current.Match(estimatedActionEnumerator.Current)) {
+        if (originalEnumerator.Current != null && estimatedActionEnumerator.Current != null
+          && originalEnumerator.Current.SameNiche(estimatedActionEnumerator.Current)) {
           correctClassified++;
         }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Evaluator/MDLEvaluator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Evaluator/MDLEvaluator.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Evaluator/MDLEvaluator.cs	(revision 9392)
@@ -20,7 +20,12 @@
 #endregion
 
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators.LCS;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -29,8 +34,47 @@
   [Item("MDLEvaluator", "Description missing")]
   [StorableClass]
-  public class MDLEvaluator : DecisionListEvaluator {
+  public class MDLEvaluator : SingleSuccessorOperator, IDecisionListEvaluator, IDecisionListOperator, IMDLCalculatorBasedOperator, IIterationBasedOperator, IStochasticOperator {
 
-    public IValueLookupParameter<MDLCalculator> MDLCalculatorParameter {
-      get { return (IValueLookupParameter<MDLCalculator>)Parameters["MDLCalculator"]; }
+    #region Parameter Properties
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ILookupParameter<DecisionList> DecisionListParameter {
+      get { return (ILookupParameter<DecisionList>)Parameters["DecisionList"]; }
+    }
+    public IValueLookupParameter<IntValue> SizePenaltyMinRulesParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["SizePenaltyMinRules"]; }
+    }
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    public IValueLookupParameter<IDecisionListClassificationProblemData> ProblemDataParameter {
+      get { return (IValueLookupParameter<IDecisionListClassificationProblemData>)Parameters["ProblemData"]; }
+    }
+
+    public ILookupParameter<MDLCalculator> MDLCalculatorParameter {
+      get { return (ILookupParameter<MDLCalculator>)Parameters["MDLCalculator"]; }
+    }
+    public ILookupParameter<IntValue> IterationsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["Iterations"]; }
+    }
+    public IValueLookupParameter<IntValue> MaximumIterationsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
+    }
+
+    public IValueLookupParameter<IntValue> IterationRuleDeletionParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["IterationRuleDeletion"]; }
+    }
+    public IValueLookupParameter<IntValue> RuleDeletionMinRulesParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["RuleDeletionMinRules"]; }
+    }
+
+    public ILookupParameter<ItemList<ItemList<IntValue>>> StrataParameter {
+      get { return (ILookupParameter<ItemList<ItemList<IntValue>>>)Parameters["Strata"]; }
+    }
+    #endregion
+
+    public IRandom Random {
+      get { return RandomParameter.ActualValue; }
     }
 
@@ -42,5 +86,15 @@
     public MDLEvaluator()
       : base() {
-      Parameters.Add(new ValueLookupParameter<MDLCalculator>("MDLCalculator", ""));
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The random generator to use."));
+      Parameters.Add(new LookupParameter<DecisionList>("DecisionList", ""));
+      Parameters.Add(new ValueLookupParameter<IntValue>("SizePenaltyMinRules", ""));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", ""));
+      Parameters.Add(new ValueLookupParameter<IDecisionListClassificationProblemData>("ProblemData", ""));
+      Parameters.Add(new LookupParameter<MDLCalculator>("MDLCalculator", ""));
+      Parameters.Add(new LookupParameter<IntValue>("Iterations", ""));
+      Parameters.Add(new ValueLookupParameter<IntValue>("MaximumIterations", ""));
+      Parameters.Add(new ValueLookupParameter<IntValue>("IterationRuleDeletion", "", new IntValue(5)));
+      Parameters.Add(new ValueLookupParameter<IntValue>("RuleDeletionMinRules", "", new IntValue(12)));
+      Parameters.Add(new ValueLookupParameter<ItemList<ItemList<IntValue>>>("Strata", ""));
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -51,14 +105,61 @@
       double penalty = 1;
 
-      var dls = new DecisionListSolution(DecisionListParameter.ActualValue, ProblemDataParameter.ActualValue);
+      var strata = StrataParameter.ActualValue;
+      int iteration = IterationsParameter.ActualValue.Value;
+      int numberOfStrata = strata.Count;
+      var dl = DecisionListParameter.ActualValue;
+      var problemData = ProblemDataParameter.ActualValue;
+      bool lastIteration = iteration == MaximumIterationsParameter.ActualValue.Value - 1;
+      IEnumerable<int> rows;
+      if (lastIteration) {
+        rows = from s in strata
+               from row in s
+               select row.Value;
+      } else {
+        rows = strata[iteration % numberOfStrata].Select(x => x.Value);
+      }
+      var input = problemData.FetchInput(rows);
+      var actions = problemData.FetchAction(rows);
+      ItemSet<Rule> aliveRules;
+      double theoryLength;
+      var estimated = dl.Evaluate(input, out aliveRules, out theoryLength);
 
-      if (dls.TrainingNumberOfAliveRules < SizePenaltyMinRulesParameter.ActualValue.Value) {
-        penalty = (1 - 0.025 * (SizePenaltyMinRulesParameter.ActualValue.Value - dls.TrainingNumberOfAliveRules));
+      if (aliveRules.Count < SizePenaltyMinRulesParameter.ActualValue.Value) {
+        penalty = (1 - 0.025 * (SizePenaltyMinRulesParameter.ActualValue.Value - aliveRules.Count));
         if (penalty <= 0) penalty = 0.01;
         penalty *= penalty;
       }
 
-      QualityParameter.ActualValue = new DoubleValue(MDLCalculatorParameter.ActualValue.CalculateFitness(dls) / penalty);
+      double accuracy = DecisionListSolution.CalculateAccuracy(actions, estimated);
+      QualityParameter.ActualValue = new DoubleValue(MDLCalculatorParameter.ActualValue.CalculateFitness(theoryLength, accuracy) / penalty);
+
+      if (iteration >= IterationRuleDeletionParameter.ActualValue.Value) {
+        if (lastIteration) {
+          DoRuleDeletion(dl, aliveRules, 1);
+        } else {
+          DoRuleDeletion(dl, aliveRules, RuleDeletionMinRulesParameter.ActualValue.Value);
+        }
+      }
       return base.Apply();
+    }
+
+    // default rule cannot be deleted, but it has to be considered in the rule set size
+    private void DoRuleDeletion(DecisionList dl, ItemSet<Rule> aliveRules, int minRules) {
+      int ruleSetSize = dl.RuleSetSize;
+      if (ruleSetSize <= minRules) { return; }
+
+      var deadRules = dl.Rules.Except(aliveRules).ToList();
+      int numberOfDeadRules = deadRules.Count();
+
+      int keepRules = minRules - (ruleSetSize - numberOfDeadRules);
+
+      if (keepRules > 0) {
+        for (int i = 0; i < keepRules; i++) {
+          int pos = Random.Next(deadRules.Count);
+          deadRules.RemoveAt(pos);
+        }
+      }
+
+      dl.RemoveRules(deadRules);
     }
   }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/HeuristicLab.Encodings.DecisionList-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/HeuristicLab.Encodings.DecisionList-3.3.csproj	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/HeuristicLab.Encodings.DecisionList-3.3.csproj	(revision 9392)
@@ -100,8 +100,5 @@
     <Compile Include="DecisionListNicheComparer.cs" />
     <Compile Include="DecisionListSolution.cs" />
-    <Compile Include="Evaluator\DecisionListEvaluator.cs" />
-    <Compile Include="Evaluator\MDLCalculator.cs" />
     <Compile Include="Evaluator\MDLEvaluator.cs" />
-    <Compile Include="Evaluator\MDLIterationOperator.cs" />
     <Compile Include="Interfaces\IDecisionListClassificationProblem.cs" />
     <Compile Include="Interfaces\IDecisionListClassificationProblemData.cs" />
